#include <bits/stdc++.h>
using namespace std;
#define PB push_back
#define ZERO (1e-10)
#define INF (1<<29)
#define CL(A,I) (memset(A,I,sizeof(A)))
#define DEB printf("DEB!"\n);
#define D(X) cout << "  "<<#X<<": "<<X<<endl;
#define EQ(A,B) (A+ZERO>B&&A-ZERO<B)
typedef long long LINT;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int, int> ii;
typedef vector<ii> vii;
#define IN(n) int n; scanf("%d", &(n));
#define FOR(i, m, n) for (int i(m); i<n; i++)
#define REP(i, n) FOR(i, 0, n)
#define F(n) REP(i, n)
#define FF(n) REP(j, n)
#define FT(m, n) FOR(k, m, n)
#define aa first
#define bb second
#define FI first
#define SE second
void ga(int N, int *A){F(N)scanf("%d",A+i);}

enum Or {L, R, U, D};
Or ll, rr, uu, dd;

#define MX 107
int n, cnt;
char m[MX][MX];
char cmd[1234567];
vi tbl[256];
char crs[256];
vi poss;

void frl() {
    Or tmp = uu;
    uu = rr;
    rr = dd;
    dd = ll;
    ll = tmp;
    for(auto i : poss) {
        crs[i] = tbl[crs[i]][1];
    }
}

void spfrl() {
    Or tmp = uu;
    uu = rr;
    rr = dd;
    dd = ll;
    ll = tmp;
}

void frr() {
    Or tmp = uu;
    uu = ll;
    ll = dd;
    dd = rr;
    rr = tmp;
    for(auto i : poss) {
        crs[i] = tbl[crs[i]][0];
    }
}

void fh() {
    swap(ll, rr);
    for(auto i : poss) {
        crs[i] = tbl[crs[i]][2];
    }
}

void fv() {
    swap(uu, dd);
    for(auto i : poss) {
        crs[i] = tbl[crs[i]][3];
    }
}

void mrl(char &a, char &b, char &c, char &d) {
    char t(a);
    a = b, b = c, c = d, d = t;
}

void mrot() {
    F(n >> 1)
        FF((n+1)>>1)
            mrl(m[i][j],m[n-1-j][i],m[n-1-i][n-1-j],m[j][n-1-i]);
}

int main() {
    poss = {'-', '/', '\\', '>', '<', '^', 'v', '|'};
    tbl['-'] = {'|', '|', '-', '-'};
    tbl['|'] = {'-', '-', '|', '|'};
    tbl['/'] = {'\\', '\\', '\\', '\\'};
    tbl['\\'] = {'/', '/', '/', '/'};
    tbl['<'] = {'^', 'v', '>', '<'};
    tbl['>'] = {'v', '^', '<', '>'};
    tbl['^'] = {'>', '<', '^', 'v'};
    tbl['v'] = {'<', '>', 'v', '^'};
    tbl['o'] = {'o', 'o', 'o', 'o'};
    tbl['x'] = {'x', 'x', 'x', 'x'};

    while (cin >> n) {
        ll = L, rr = R, uu = U, dd = D;
        REP(i, n)
            REP(j, n)
            scanf(" %c ", &m[i][j]);
        cnt = 0;
        while (1) {
            char c;
            scanf("%c", &c);
            if (c == ' ')
                continue;
            if (c == '\n')
                break;
            cmd[cnt++] = c;
        }
        crs['-'] = '-';
        crs['|'] = '|';
        crs['/'] = '/';
        crs['\\'] = '\\';
        crs['<'] = '<';
        crs['>'] = '>';
        crs['^'] = '^';
        crs['v'] = 'v';
        crs['o'] = 'o';
        crs['x'] = 'x';

        REP(i, cnt) {
            // D(cmd[i]);
            switch(cmd[i]) {
                case '-':
                    fv();
                    break;
                case '/':
                    fh();
                    frr();
                    break;
                case '\\':
                    fv();
                    frr();
                    break;
                case '|':
                    fh();
                    break;
                case '>':
                    frr();
                    break;
                case '<':
                    frl();
                    break;
            }
            // D(uu) D(ll) D(rr) D(dd);
        }

        if (uu == L || uu == R) {
            if (rr == U) {
                mrot();
                mrot();
                mrot();
                spfrl();
            } else {
                mrot();
                spfrl();
                spfrl();
                spfrl();
            }
        }
        // D(uu) D(ll) D(rr) D(dd);
        if (uu == D) {
            // printf("horedole\n");
            REP(i, n / 2) {
                REP(j, n) {
                    swap(m[i][j], m[n-i-1][j]);
                }
            }
        }
        if (ll == R) {
            // printf("lavopravo\n");
            REP(i, n) {
                REP(j, n / 2) {
                    swap(m[i][j], m[i][n-j-1]);
                }
            }
        }
        REP(i, n) {
            REP(j, n) {
                m[i][j] = crs[m[i][j]];
            }
        }
        REP(i, n) {
            REP(j, n) {
                printf("%c", m[i][j]);
            }
            printf("\n");
        }
    }
}

/*
  cmd[i]: <
  uu: 1
  ll: 2
  rr: 3
  dd: 0
  cmd[i]: |
  uu: 1
  ll: 3
  rr: 2
  dd: 0
o/>
<>x
|-<
  cmd[i]: |
  uu: 2
  ll: 1
  rr: 0
  dd: 3
  cmd[i]: \
  uu: 0
  ll: 3
  rr: 2
  dd: 1
  cmd[i]: |
  uu: 0
  ll: 2
  rr: 3
  dd: 1
<</o\
</ooo
/ooo|
oooo^
\o-<x
  cmd[i]: -
  uu: 3
  ll: 0
  rr: 1
  dd: 2
vx^
\v|
o^-
*/
